﻿using System;
using System.Net;

namespace Veracode.HmacExample.App
{
    public class Program
    {
        private const string AuthorizationHeader = "Authorization";
        private const string ApiId = "VERACODE_API_ID_GOES_HERE";
        private const string ApiKey = "VERACODE_SECRET_KEY_GOES_HERE";

        public static void Main(string[] args)
        {
            try
            {
                const string urlBase = "analysiscenter.veracode.com";
                const string urlPath = "/api/5.0/getapplist.do";
                var urlParams = string.Empty;
                const string httpVerb = "GET";

                var webClient = new WebClient
                {
                    BaseAddress = $"https://{urlBase}"
                };

                var authorization = HmacAuthHeader.HmacSha256.CalculateAuthorizationHeader(ApiId, ApiKey, urlBase, urlPath, urlParams, httpVerb);

                webClient.Headers.Add(AuthorizationHeader, authorization);

                var result = webClient.DownloadString(urlPath);

                Console.WriteLine(result);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
            finally
            {
                Console.WriteLine("Press any key to continue.");
                Console.ReadKey();
            }
        }
    }
}
